version: '3.4'

services:
  api: 
    build: ./api
    ports:
      - "3000:3000"
    volumes:
      - "./api:/usr/src"
      - "api_dependencies:/usr/src/node_modules"
    env_file:
      - "./api/.env"

  sink:
    build: ./sink
    volumes:
      - "./sink:/usr/src"
      - "sink_dependencies:/usr/src/node_modules"
    env_file:
      - "./sink/.env"
  
  cache:
    container_name: cache
    image: redis:5.0.3-alpine
    restart: always
    volumes:
      - "cache:/data"
    ports:
      - "6379:6379"

  streaming:
    container_name: streaming
    image: nats-streaming:0.11.2-linux
    restart: always
    volumes:
      - "streaming:/store"
    ports:
      - "4222:4222"
      - "8222:8222"
    command:
      "-m 8222 -store file -dir /store"

volumes:
  api_dependencies:
  sink_dependencies:
  streaming:
  cache:
